- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_waf_web_acl – create and delete WAF Web ACLs

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Read the AWS documentation for WAF https://aws.amazon.com/documentation/waf/

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- boto

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
default_action - | Choices: block allow count | The action that you want AWS WAF to take when a request doesn't match the criteria specified in any of the Rule objects that are associated with the WebACL
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
metric_name - |  | A friendly name or description for the metrics for this WebACL The name can contain only alphanumeric characters (A-Z, a-z, 0-9); the name can't contain whitespace. You can't change metric_name after you create the WebACL Metric name will default to name with disallowed characters stripped out
name - / required |  | Name of the Web Application Firewall ACL to manage
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
purge_rules boolean | Choices: no ← yes | Whether to remove rules that aren't passed with `rules`.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
rules - |  | A list of rules that the Web ACL will enforce. Each rule must contain name, action, priority keys. Priorities must be unique, but not necessarily consecutive. Lower numbered priorities are evaluated first. The type key can be passed as `rate_based`, it defaults to `regular`
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | whether the Web ACL should be present or absent
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
waf_regional boolean added in 2.9 | Choices: no ← yes | Whether to use waf_regional module. Defaults to false.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: create web ACL
      aws_waf_web_acl:
        name: my_web_acl
        rules:
          - name: my_rule
            priority: 1
            action: block
        default_action: block
        purge_rules: yes
        state: present

    - name: delete the web acl
      aws_waf_web_acl:
        name: my_web_acl
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
web_acl complex | always | contents of the Web ACL
| default_action dictionary | always | Default action taken by the Web ACL if no rules match Sample: {'type': 'BLOCK'}
| metric_name string | always | Metric name used as an identifier Sample: mywebacl
| name string | always | Friendly name of the Web ACL Sample: my web acl
| rules complex | always | List of rules
|  | action complex | always | Action taken by the WAF when the rule matches Sample: {'type': 'ALLOW'}
|  | priority integer | always | priority number of the rule (lower numbers are run first) Sample: 2
|  | rule_id string | always | Rule ID Sample: a6fc7ab5-287b-479f-8004-7fd0399daf75
|  | type string | always | Type of rule (either REGULAR or RATE_BASED) Sample: REGULAR
| web_acl_id string | always | Unique identifier of Web ACL Sample: 10fff965-4b6b-46e2-9d78-24f6d2e2d21c

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Mike Mochan (@mmochan)
- Will Thames (@willthames)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.